/*  File:     cnctClientMessagejava 
    Project:  OOPracktikum 2001
	            Connect-Game Client
	            Patrick Scheibe, Markus Kreuz, Georg Martius
    Autor:
    Package:  cnctGameClient
    Descript: verwaltet die Messages und zeichnet den Text
    last mod Fri May 11 10:44:54 MEST 2001 
*/

package cnctGameClientPack;

import java.util.Vector;
import java.awt.*;
import point;



class message extends Object{
  public String msg;
  public int type;
  
  public message(String _msg, int _type) { msg = _msg; type = _type; }
};

public class cnctClientMessage
{          
	 private cnctClientPanel parent;

     private Vector messages;
     private int displayFrom = 0;
     
     private point topleft;
     private point size;
     private int linenumber = 10;
     private Font font;
     private FontMetrics fontmetrics;
     private int maxLineLength=40;
	 private boolean isinit = false;

     public static final byte INFO = 2;     
     public static final byte NORMAL = 1;
     public static final byte ERROR = 0;
     public static final byte IMPORTANT = 3;
          
     /////////////////////////////////////////// F U N K T I O N E N ///////////////////////////
     // public cnctClientMessage();
     // public void init(point _topleft, point _size){
     // public void addMessage(String message,byte type);
     // public void paint(Graphics g);
     // public void close()

     /////////////////////////////////////////// I M P L E M E N T I E R U N G ///////////////////////////

     
     //Konstruktor
     //--------------------------------------------------------------------------
     public cnctClientMessage(cnctClientPanel _parent){
       messages = new Vector();
	   parent = _parent;
     }
     
     //----------------------------------------------------------------------------     
     public void init(point _topleft, point _size){
       topleft= _topleft;
       size = _size;
       font = new Font("serif", Font.PLAIN,  size.y/(linenumber+2));
       isinit = true;
     }

 
     // fuegt neue Meldung hinzu    
     //----------------------------------------------------------------------------     
     public void addMessage(String msg,byte type){
	   if(msg.length() > maxLineLength){
	     addMessage(msg.substring(0,maxLineLength), type);
		 msg=msg.substring(maxLineLength,msg.length());
	   }  
       messages.addElement(new message(msg, type));
       if (messages.size() - displayFrom > linenumber){
         displayFrom=messages.size()-linenumber+(linenumber/3);
         if (displayFrom < 0) displayFrom=0;
       }
     }
     
     
     // zeichnet den ganzen Kram 
     //----------------------------------------------------------------------------     
     public void paint(Graphics g){
       if (!isinit) return;
       
       int i, maxcount = linenumber+displayFrom > messages.size() ?  messages.size()-displayFrom : linenumber;

       g.setFont(font);       
       fontmetrics = g.getFontMetrics();
	   // Laenge einer Zeile berechnen
       maxLineLength= size.x / fontmetrics.charWidth('d');
	   // RAHMEN malen
       g.setColor( Color.black);
       g.drawRect(topleft.x, topleft.y, size.x, size.y);
       g.setColor( Color.white);
       g.fillRect(topleft.x+1, topleft.y+1, size.x-2, size.y-2);
       
       // Text ausgeben
       for(i = 0; i <  maxcount; i++){
         switch (((message)messages.elementAt(i+displayFrom)).type){
	   case INFO:
	     g.setColor(Color.green);
	   break;
	   case NORMAL:
	     g.setColor(Color.black);
	   break;
	   case ERROR:
	     g.setColor(Color.red);	   
	   break;
	   case IMPORTANT:
	     g.setColor(Color.cyan);
	   break;
	 }
         g.drawString( ((message)messages.elementAt(i+displayFrom)).msg, topleft.x +10, topleft.y + (int)((double)(i+0.5)*size.y / (linenumber+1) + fontmetrics.getHeight()));
       }
     }

     // leert Vektor
     //----------------------------------------------------------------------------     
     public void close(){
        messages.removeAllElements();
     }
}
