/*  File:     cnctClientPanel.java 
    Project:  OOPracktikum 2001
	            Connect-Game Client
	            Patrick Scheibe, Markus Kreuz, Georg Martius
    Autor:
    Package: cnctGameClient
    Descript: Anzeige das Connect Spiel-Client 
              uebernimmt Grafische Ausgabe und den Socket Betrieb
    last mod: Mon Apr 30 23:28:27 CEST 2001            
*/

package cnctGameClientPack;

import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.io.*;


import point;
import cnctSocket.*;
import cnctGame.*;

public class cnctClientPanel extends Panel implements cnctSocketEvent, MouseListener, ComponentListener 
{ 
//Member
public  cnctSocketClient socket;
private feld spielFeld;
private int yourcolor=0;
private int othercolor=1;
private String playerName;
private point feld_offset;
private point feld_size;
private boolean feldisinit=false;
private Font feldFont;
private String oppositeName;
private point last= new point();

public cnctClientMessage messages;

//Konstanten
///!!! ins Feld
public final int BLACK=0;
public final int WHITE=1;

   /////////////////////////////////////D E K L A R A T I O N E N/////////////////////
   //###Feld Zeichnen
   // public void paintFeld(Graphics g){
   // public void close()
   
   //public void setPlayerName(String name);

    //######## P R I V A T E ####
   //###Koordinaten Berechnung (von Spielfeld(1..breite,1..hoehe) zu Bildschirm
   // private point feld2screen(point _pos);
   //###Koordinaten Berechnung (von Bildschirm zum Spielfeld(1..breite,1..hoehe)
   // private point screen2feld(point _pos);
   //###prueft ob pos(Screen) ueber dem Feld ist
   // private boolean checkPosition(point _pos)



  ///////////////////////////////////// D E F I N I T I O N E N /////////////////////
  // bekommt Groesse des Clientfensters
   public cnctClientPanel(point _size, String host, int port, String playername){
      messages = new cnctClientMessage(this);
      oppositeName=new String("Unbekannt");
      
      try{
        socket=new cnctSocketClient((cnctSocketEvent)this,host,port);
        playerName= new String(playername);
        if (playerName!=""){
          socket.setPlayerName(playerName);
        } 
        socket.start();
      }catch(cnctSocketException e){        
         System.out.println("cnctClientPanel::cnctClientPanel: Fehler beim ffnen des Sockets (Host: " + host + ":" + port + ")");
         messages.addMessage("Fehler beim ffnen des Sockets (Host: " + host + ":" + port + ")", cnctClientMessage.ERROR);
      }
      
	  /*Listener setzen*/
	  this.addComponentListener(this);
      this.addMouseListener(this);
      
	  setSize(_size);
      
      if(socket!=null){
        messages.addMessage("Verbindung zu: Host: " + host + ":" + port, cnctClientMessage.INFO);        
      }
   }

   public void close(){
      if (socket!=null) socket.close();
   }
   
   public void setSize(point _size){
     feld_offset=new point(_size.x/10,_size.y/13);
     feld_size=new point(_size.x*8/10,_size.y*8/13);
	 
	 messages.init(new point((int)(feld_offset.x/2.0),(int)(2*feld_offset.y) + feld_size.y ), new point( feld_size.x+feld_offset.x , (int) (_size.y*3.0/13.0)));      
  
   }

    //public void setPlayerName(String name);

   //overloaded from awt.Container
   //-------------------------------------------------------------------------------------
   public void paint(Graphics g){
     messages.paint(g);
     if (feldisinit) paintFeld(g);    
   }


  ///////////// Socket Events
  //---------------------------------------------------------------------------------------
   public void gamesize(int size){
     spielFeld=new feld(size);
     feldisinit=true;
     repaint();
     System.out.println("Gamsize is: "+ size);
     messages.addMessage("Spielgre: "+ size, cnctClientMessage.NORMAL);     
   }
   
  //---------------------------------------------------------------------------------------
   public void youbegin(boolean youstart){
     if(youstart){
        yourcolor=BLACK;
        othercolor=WHITE;
        System.out.println("I begin");
        messages.addMessage("Du beginnst !", cnctClientMessage.IMPORTANT);
     }else{
        yourcolor=WHITE;
        othercolor=BLACK;
        System.out.println("the other begin");
        messages.addMessage("Dein Gegner beginnt !", cnctClientMessage.IMPORTANT);
     } 
     repaint();
   }
   
  //---------------------------------------------------------------------------------------
   public void youhavetoturnto(point position){
       if (spielFeld.setposition(position,yourcolor)==false) 
          System.out.println("cnctapplet::youhavetoturnto: Fehler");
       System.out.println("you had have to set to: (" + position.x + "/" + position.y + ")");
       messages.addMessage("Du wurdest angewiesen auf (" + position.x + "/" + position.y + ") zu ziehen", cnctClientMessage.NORMAL);
       repaint();

   }
  //---------------------------------------------------------------------------------------
   public void end(String reason){
       System.out.println("game ends: " + reason);  
       messages.addMessage("Spiel ist zuende: " + reason, cnctClientMessage.IMPORTANT);
       repaint();
   }
   
  //---------------------------------------------------------------------------------------
   public void getturn(point position){
       ///!!!Exception
       if (spielFeld.setposition(position,othercolor)==false) 
          System.out.println("cnctapplet::getturn: Fehler");
       System.out.println("the other has set: (" + position.x + "/" + position.y + ")");
       messages.addMessage("Der Andere hat gezogen auf: (" + position.x + "/" + position.y + ")", cnctClientMessage.NORMAL);
       
       setLastSet(position);
          
       repaint();
   }
   
   
  //---------------------------------------------------------------------------------------
   public void yourturn(int timeout){
       System.out.println("you have to turn in the next " + timeout + " seconds");
       messages.addMessage("Du bist dran! Zeit noch " +timeout + " Sekunden.", cnctClientMessage.INFO);      
   }

  //---------------------------------------------------------------------------------------
   public void oppositename(String _oppname){
       System.out.println("Your Opposite is " + _oppname);
       messages.addMessage("Dein Gegner heisst: " + _oppname, cnctClientMessage.NORMAL);      
       oppositeName=_oppname;
   }
   
   
   //-------------------------------------------------------------------------------------
   //Gibt den Namen des Gegners nach Aussen zurueck
   public String getOppositeName()
   {        
          
          if(oppositeName!=null)
            return oppositeName;
          else
            return "---";
   }          



  /////////////Letzter zug
  //--------------------------------------------------------------------------------------
  
  private boolean getLastSet(int x,int y)
  {
        if(x==last.x && y==last.y)
          return true;
        else
          return false;
  }      
  

  private void setLastSet(point _last)
  {
    last.x=_last.x;
    last.y=_last.y;
  }



  //////////// MouseEvents
  //---------------------------------------------------------------------------------------
  public void mouseClicked(MouseEvent e){
  
    // pruefen ob im Feld und auf gueltigem Feld->wenn ja dann loschicken
    if(!feldisinit) return;
    
    point fieldkoord=new point();
    point mousepos=new point(e.getX(),e.getY());
    if(!checkPosition(mousepos))
       return;
       
    fieldkoord=screen2feld(mousepos);
    if (spielFeld.getValid(fieldkoord,yourcolor)){  // wenn Feld gueltig dann sende Zug
     if(socket.sendturn(fieldkoord)){ // OK
            // Zug setzen (lokal)
            setLastSet(fieldkoord);
            System.out.println("Der letzte Zug war: " + last.x + " " + last.y + "\n"); 
              //letzten Zug speichern        
         if(spielFeld.setposition(fieldkoord,yourcolor)==false)
           System.out.println("cnctapplet::mouseClicked: Fehler");
        
	 repaint(); // auffrischen   
      }else{  // ich bin gar nicht dran
        System.out.println("Du bist ueberhaupt nicht an der Reihe!");
      }
    }
  }

  
  public void mouseEntered(MouseEvent e){
  }
  public void mouseExited(MouseEvent e){
  }
  public void mousePressed(MouseEvent e){
  }
  public void mouseReleased(MouseEvent e){
  }
  
  //////////// ComponentEvents
  //---------------------------------------------------------------------------------------
  
  public void componentResized(ComponentEvent e){
    Dimension _size=getSize();
	setSize(new point(_size.width, _size.height));
	
  }

  public void componentMoved(ComponentEvent e){
  }
  
  public void componentShown(ComponentEvent e){
  }

  public void componentHidden(ComponentEvent e){
  }


  //Koordinaten Berechnung (von Spielfeld(1..breite,1..hoehe) zu Bildschirm
  //---------------------------------------------------------------------------------------
   private point feld2screen(point _pos){
          ///!!!Exception
     if(!feldisinit) return new point(0,0);
     int feld_dim=spielFeld.getHeight();
     return new point(feld_offset.x + (int)((double)(_pos.x-1)*((double)feld_size.x/(double)feld_dim)), feld_size.y + feld_offset.y - (int)((double)(_pos.y-1)*((double)feld_size.y/(double)feld_dim)) );
   }
   
  //Koordinaten Berechnung (von Bildschirm zum Spielfeld(1..breite,1..hoehe)
  //---------------------------------------------------------------------------------------
   private point screen2feld(point _pos){
         ///!!!Exception   
     if(!feldisinit) return new point(0,0);
    
     int feld_dim=spielFeld.getHeight();
     return new point( (int)((double)(_pos.x-feld_offset.x)/((double)feld_size.x/(double)feld_dim)) + 1,  (int)((double)(feld_size.y - _pos.y + feld_offset.y)/((double)feld_size.x/(double)feld_dim)) + 1);     
   }
  //prueft ob pos(Screen) ueber dem Feld ist
  //---------------------------------------------------------------------------------------
   private boolean checkPosition(point _pos){
     if( (_pos.x < feld_offset.x) || (_pos.y < feld_offset.y) || (_pos.x > feld_offset.x+feld_size.x) || (_pos.y > feld_offset.y+feld_size.y) ){
       return false;
     }
     return true;
   }


  //Feld Zeichnen
  //---------------------------------------------------------------------------------------  
   public void paintFeld(Graphics g){
     int feld_dim=spielFeld.getHeight();
     byte feldcontent;		//Feldinhalt
     point blcorner;		//untere linke Ecke
     // groesse eines Kaestchens
     point fieldsize=new point(feld_size.x/feld_dim, feld_size.y/feld_dim );
     FontMetrics fontmetr;

     //Hintergrund ausfuellen
     g.setColor(new Color(200,140,25)); // warmes leicht roetliches braun
     g.fillRect(feld_offset.x-fieldsize.x, feld_offset.y-fieldsize.y, feld_size.x+2*fieldsize.x, feld_size.y+2*fieldsize.y);     
     //Rahmen Malen
     g.setColor(Color.black);
     g.drawRect(feld_offset.x-1, feld_offset.y-1, feld_size.x+2, feld_size.y+2);
     g.drawRect(feld_offset.x-fieldsize.x, feld_offset.y-fieldsize.y, feld_size.x+2*fieldsize.x, feld_size.y+2*fieldsize.y);
     
     
     feldFont= new Font("serif", Font.BOLD, fieldsize.y*8/10);
     g.setFont(feldFont); 
     fontmetr=g.getFontMetrics();
     
     for(int i=1;i<=feld_dim;i++){
        for(int j=1; j<=feld_dim;j++){
           //Positions bestimmen
      	   blcorner=feld2screen(new point(i,j));	

           //Felder mahlen
           feldcontent=spielFeld.getposition(i,j);

      	   if (feldcontent==spielFeld.EMPTYFELD) {
	     g.setColor(Color.blue);
//             g.fillRect(blcorner.x, blcorner.y-fieldsize.y, fieldsize.x, fieldsize.y);	
           }
	   
	   if (feldcontent==spielFeld.BLACKNOSET){
	      g.setColor(Color.white);
//             g.fillRect(blcorner.x, blcorner.y-fieldsize.y, fieldsize.x, fieldsize.y);
      	   }
	   
	   if (feldcontent==spielFeld.WHITENOSET){
	     g.setColor(Color.black);
//             g.fillRect(blcorner.x, blcorner.y-fieldsize.y, fieldsize.x, fieldsize.y);
           }
	   
	   if (feldcontent==spielFeld.NOSET){
	      g.setColor(Color.red);
	      if ((i==1 && j==1)||(i==1 && j==feld_dim)||(j==1 && i==feld_dim)||(i==feld_dim && j==feld_dim)){
	           //Ecken nicht
	      } else{
	         if(i%2==0 && j%2!=0){
	           g.setColor(Color.black);
	         }else{
	                g.setColor(Color.white);
	               }
	            g.fillArc(blcorner.x+fieldsize.x/3,blcorner.y-fieldsize.y*2/3,fieldsize.x/3,fieldsize.y/3,0,360);
                 }
           }
	   
	   if ( (feldcontent & spielFeld.WHITE_IS_SET) !=0 ){
	      g.setColor(Color.white);
            if(last.x==i && last.y==j)
          
              g.setColor(new Color(50,255,50));
            
	      if(i%2!=0){ // senkrechte Linie
          
            
              g.drawLine(blcorner.x+fieldsize.x/2,blcorner.y+fieldsize.y/2,blcorner.x+fieldsize.x/2,blcorner.y-fieldsize.y*3/2);
	      
          
          }else{ // waagerechte Linie
          
            
	        g.drawLine(blcorner.x-fieldsize.x/2,blcorner.y-fieldsize.y/2,blcorner.x+fieldsize.x*3/2,blcorner.y-fieldsize.y/2);

	      }
    //          g.fillRect(blcorner.x, blcorner.y-fieldsize.y, fieldsize.x, fieldsize.y);
           }
	   if ( (feldcontent & spielFeld.BLACK_IS_SET) !=0 ){
	      g.setColor(Color.black);
           if(last.x==i && last.y==j)
              g.setColor(new Color(0,0,200));
          
	      if(i%2==0){ // senkrechte Linie
	        g.drawLine(blcorner.x+fieldsize.x/2,blcorner.y+fieldsize.y/2,blcorner.x+fieldsize.x/2,blcorner.y-fieldsize.y*3/2);
	      }else{ // waagerechte Linie
	        g.drawLine(blcorner.x-fieldsize.x/2,blcorner.y-fieldsize.y/2,blcorner.x+fieldsize.x*3/2,blcorner.y-fieldsize.y/2);

	      }
	      
           }
	   
                      
        }
     }

    
    // Zahlen hinschreiben
     g.setColor(Color.black);
     for(int i=1;i<=feld_dim;i++){ 
            //Beschriftung malen
	    blcorner=feld2screen(new point(i,i));
           // in y-Richtung malen
             g.drawString(String.valueOf(i),feld_offset.x-(fieldsize.x+fontmetr.stringWidth(String.valueOf(i)))/2, blcorner.y-fieldsize.y/2 + fontmetr.getHeight()/3);
             g.drawString(String.valueOf(i),feld_offset.x+feld_size.x+(fieldsize.x-fontmetr.stringWidth(String.valueOf(i)))/2, blcorner.y-fieldsize.y/2 + fontmetr.getHeight()/3);
           // in x-Richtung malen
             g.drawString(String.valueOf(i),blcorner.x+(fieldsize.x-fontmetr.stringWidth(String.valueOf(i)))/2, feld_offset.y-fieldsize.y/2+fontmetr.getHeight()/3);
             g.drawString(String.valueOf(i),blcorner.x+(fieldsize.x-fontmetr.stringWidth(String.valueOf(i)))/2, feld_offset.y+feld_size.y+fieldsize.y/2+fontmetr.getHeight()/3);

     }
   
   
   }// end of paintFeld

}
