/*  File:     cnctInfoPanel.java 
    Project:  OOPracktikum 2001
	            Connect-Game Client
	            Patrick Scheibe, Markus Kreuz, Georg Martius
    Autor:
    Descript: Anzeige das Connect Info-Client 
              uebernimmt Grafische Ausgabe und den Socket Betrieb
    last mod: Tue Mar 27 10:33 


*/
package cnctInfoClientPack;

import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.io.*;

import cnctInfoClient;
import point;

public class cnctInfoNewDlg extends Dialog implements ActionListener
{ 
	private TextField sizefield;
	private Button okbutton;
	private Button cancelbutton;    
	private Panel panel;
	private Label command;
	private cnctInfoClient parent;
	private CheckboxGroup colorbox = new CheckboxGroup();
	private Checkbox black = new Checkbox("Black",colorbox,true);
	private Checkbox white = new Checkbox("White",colorbox,false);
	
	
	public int gamesize;
	public int color;
	
	public cnctInfoNewDlg(Frame pw,String title)
	{
		super(pw,title,false);
		parent=(cnctInfoClient)pw;
		panel=new Panel();
		command=new Label("Ganze ungerade Zahl (3-21) : ");
		sizefield=new TextField(10);

		okbutton=new Button("Start");
        cancelbutton=new Button("Cancel");
        
		add(panel);
		panel.setLayout(new FlowLayout(FlowLayout.CENTER));
		panel.add(command);
		panel.add(sizefield);
		panel.add(black);
		panel.add(white);
		panel.add(okbutton);
		okbutton.addActionListener(this);
		panel.add(cancelbutton);
		cancelbutton.addActionListener(this);
		pack();	
	}


  ///////// ACTIONEVENTS  
  //---------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent ae)
	{
		Object source=ae.getSource();
		if (source==okbutton){
			if (sizefield.getText().length()!=0){
				if (black.getState()==true)
					color=cnctInfoPanel.BLACK;
				else color=cnctInfoPanel.WHITE;

	          try{
 	            gamesize = (new Integer(sizefield.getText())).intValue();
 		      }catch(NumberFormatException e){
             	System.err.println("Wrong Size");        
              	return;
			  }
				if(gamesize<5 || gamesize>21 || gamesize%2==0)
					return;
				setVisible(false);
				parent.startNewGame(gamesize,color);
			}
		}else
        if(source==cancelbutton){
          setVisible(false);
        }
	}
}
