/*  File:     cnctInfoPlayer.java 
    Project:  OOPracktikum 2001
	            Connect-Game Client
	            Patrick Scheibe, Markus Kreuz, Georg Martius
    Package:  cnctInfoSocket
    Autor:    
    Descript: Player mit seinem Status
    last mod: Mon Apr 30 23:28:27 CEST 2001
*/

package cnctInfoSocket;

import java.io.*;
import java.net.*;
import java.util.Vector;

import cnctParser.*;

public class cnctInfoPlayer extends Object{
    //member
    private String name;
    private int status;
    private int gameNumber;
    private int color;

    public static final int IDLE = 1;
    public static final int WAITING = 2;
    public static final int PLAYING = 3;
    public static final int WATCHING = 4;
          
    public static final int BLACK = 0;
    public static final int WHITE = 1;


    /////////////////////////////////////////// F U N K T I O N E N ///////////////////////////
    //  public cnctInfoPlayer();
 
    //  public cnctInfoPlayer(String _name, int _status, int _gameNumber);

    //  public String getName(){
  
    //  public int getStatus(){
    
    //  public String getStatusString(){
    //  public int getGameNumber(){
    //  public int getColor(){
    //  public void setName(String playername){
    
    //  private boolean setStatus(String stat){
    //  private boolean setColor(String col){
    
    ///////////////////////////////////////// I M P L E M E N T I E R U N G ///////////////////////////
    //------------------------------------------------------
    public cnctInfoPlayer(){
      status=0;
      gameNumber=0;
      color=0;
    };
 
    //------------------------------------------------------
    public cnctInfoPlayer(String _name, int _status, int _gameNumber){
      name=_name;
      status=_status;
      gameNumber=_gameNumber;
    };
    
    //-----------------------------------------------------
    public String getName(){
      return name;
    };
    
    //-----------------------------------------------------
    public int getStatus(){
      return status;
    };
    
    //-----------------------------------------------------
    public String getStatusString(){
      switch(status){
        case IDLE: return new String("IDLE");
        case WAITING: return new String("WAITING");
        case PLAYING: return new String("PLAYING");
        case WATCHING: return new String("WATCHING");
      }
      return null;
    };
    
    //-----------------------------------------------------
    public int getGameNumber(){
      return gameNumber;
    };
    
    //-----------------------------------------------------
    public void setGameNumber(int number){
      gameNumber=number;
    };

    //-----------------------------------------------------
    public int getColor(){
      return color;
    };

    //------------------------------------------------------
    public boolean setStatus(String stat){
      if(stat==null) return false;
      stat=stat.trim();
      if (stat.toUpperCase().compareTo("IDLE") == 0){
        status=IDLE;
      }else 
      if (stat.toUpperCase().compareTo("WAITING") == 0){
        status=WAITING;
      }else
      if (stat.toUpperCase().compareTo("PLAYING") == 0){
        status=PLAYING;       
      }else
      if (stat.toUpperCase().compareTo("WATCHING") == 0){
        status=WATCHING;
      }else{
        return false;
      }
      return true;
    }
    

    //------------------------------------------------------        
    public void setName(String playername){
      name=playername;
    }

    //------------------------------------------------------    
    public boolean setColor(String col){
      if(col==null) return false;
      col=col.trim();
      if (col.toUpperCase().compareTo("SCHWARZ") == 0){
        color=BLACK;
      }else 
      if (col.toUpperCase().compareTo("WEISS") == 0){
        color=WHITE;
      }else{
        return false;
      }
      return true;
    }


    
}
