/*  File:     cnctSocketClient.java 
    Project:  OOPracktikum 2001
	            Connect-Game Client
	            Patrick Scheibe, Markus Kreuz, Georg Martius
    Package:  cnctSocket
    Autor:    
    Descript: Klasse um das Protokoll zu verwalten:
               lauschen auf Port
               Auslsen von Events
    last mod:  Die Mai  8 00:49:55 CEST 2001
*/

package cnctSocket;
/*
  Klasse um das Protokoll zu verwalten:
    lauschen auf Port
    beantworten bzw. auslsen von Events
*/

import point;


public class cnctSocketClient extends lineSocket {
    // Eventhandler-objekt
    private cnctSocketEvent event;
    private String name="cnctClient-0.1";    
    private boolean stopListening;
    
    private boolean canITurn;           // legt fest ob man aufgefordert wird zu ziehen
    
    /////////////////////////////////////////// F U N K T I O N E N ///////////////////////////
    // cnctSocketClient(cnctSocketEvent _event, String _hostname, int _port);
    // init(String _hostname, int _port);
    // public void run();
    // public void stop();
    // public void close();
    // private void handleInput(String input);
    //###schneidet den Kommentar ab    
    // private String cutComment(String input);
    //###extrahiert den Kommentar
    // private String getComment(String input){
    //###sendet den eigenen Zug ab.
    // public boolean sendturn(point koord);
	//###gibt auf
	// public boolean resign();
	//###setzt aus
	// public boolean pass();
	
    // public void setPlayerName(String _name){

    
    

    /////////////////////////////////////////// I M P L E M E N T I E R U N G ///////////////////////////

    
    //Konstruktor fuer Initialisierung mit Werten
    //--------------------------------------------------       
    public cnctSocketClient(cnctSocketEvent _event, String _hostname, int _port) throws cnctSocketException{
       super(_hostname, _port);
       event=_event;
       stopListening=false;
       canITurn=false;
    }
    
    
    /*lauscht auf Socket und ruft Events auf*/
    //---------------------------------------------------------------------------------
    public void run() {
      String buffer = new String("");
     
      while (stopListening==false){
        try{
            buffer=read();
	}catch(cnctSocketException e){
	  e.printStackTrace(System.out);
	}
        if (buffer!=null && buffer!="") handleInput(buffer);
           
        try {
          sleep(100);
        }catch(InterruptedException e) {
          //###
          System.out.println("cnctSocketClient::run: error while sleep ->" + e);
        }      
      }
      super.close();
      
    }
    
    //---------------------------------------------------------------------------------
    public void setPlayerName(String _name){
      name = _name;
    }
 
    // behandelt den String, der auf dem Socket gelesen wurde
    //---------------------------------------------------------------------------------
    private void handleInput(String input){
      String buffer, comment;
      int submit, pos;
      Integer tempint;
      
      // Kommentare aus dem String extrahieren
      comment = getComment(input);
      input = cutComment(input);
      
      // Leerzeichen und whitespaces wegmachen
      input=input.trim();       
      
      if (input.startsWith("Das_Spielfeld_ist ")){
        super.send("OK");
        buffer=input.substring((new String("Das_Spielfeld_ist ")).length());
        try{
          tempint=new Integer(buffer);
          event.gamesize(tempint.intValue());
        }catch(NumberFormatException e){
          System.out.println("cnctSocketClient::handleInput: "+e);
        }

      }else 


      if (input.startsWith("Dein_Gegner_ist ")){        
        super.send("OK");
	buffer=input.substring((new String("Dein_Gegner_ist \"")).length());
	event.oppositename(buffer.substring(0,buffer.length()-1));
      }else 


      if (input.compareTo("Der_andere_beginnt")==0){
        event.youbegin(false);
        super.send("OK");
      }else 

      if (input.compareTo("Du_beginnst")==0){
        event.youbegin(true);
        super.send("OK");
      }else 

      if (input.startsWith("Der_andere_zieht ")){
        Integer turnx,turny;  
        super.send("OK");
        buffer=input.substring((new String("Der_andere_zieht ")).length());
        try{
          //Ermittelt Zugposition
          turnx=new Integer(new String(buffer.substring(buffer.indexOf(" (")+2,buffer.indexOf(","))));
          turny=new Integer(new String(buffer.substring(buffer.indexOf(",")+1,buffer.indexOf(")"))));
          event.getturn(new point(turnx.intValue(),turny.intValue()));
        }catch(NumberFormatException e){
          ///!!!
          System.out.println("cnctSocketClient::handleInput: "+e);
        }
      }else  
      
      if (input.startsWith("Du_ziehst ")){
        Integer turnx,turny;  
        super.send("OK");
        buffer=input.substring((new String("Du_ziehst ")).length());
        try{
          //Ermittelt Zugposition
          turnx=new Integer(new String(buffer.substring(buffer.indexOf(" (")+2,buffer.indexOf(","))));
          turny=new Integer(new String(buffer.substring(buffer.indexOf(",")+1,buffer.indexOf(")"))));
          event.youhavetoturnto(new point(turnx.intValue(),turny.intValue()));
        }catch(NumberFormatException e){
          ///!!!
          System.out.println("cnctSocketClient::handleInput: "+e);
        }
      }else  
        
      if (input.compareTo("Wo_ziehst_du")==0){
          canITurn=true; // jetzt kann man ziehen
          int timeout;
          pos = comment.indexOf("noch");
          if (pos > 0) {
              tempint= new Integer(new String(comment.substring(pos+5,comment.indexOf("s")-1)));
              event.yourturn(tempint.intValue());
          }else{
              event.yourturn(600);
              System.out.println("cnctSocketClient::handleInput: Kommentar unklar: Kommando:"+ input + " Kommentar: " + comment);
          }
      }else 

      if (input.compareTo("Ende")==0){
        super.send("OK");
        event.end(comment);
      }else 

      if (input.compareTo("Wer_bist_du")==0){
        ///!!!Eventuell Funktion
        super.send("Ich_bin \""+name+"\"");        
      }else{
        super.send("Ich_verstehe_nicht");
        System.out.println("cnctSocketClient::handleInput: Ich_verstehe_nicht Kommando:"+ input + " Kommentar: " + comment);
      }    
    }
    
    
    //schneidet den Kommentar ab    
    //---------------------------------------------------------------------------------
    private String cutComment(String input){
       int routepos = input.indexOf("#");
       if (routepos<=0)
         return input;
       else
         return input.substring(0,routepos);
    }
    
    //extrahiert den Kommentar
    //---------------------------------------------------------------------------------
    private String getComment(String input){
       int routepos = input.indexOf("#");
       if (routepos<=0)
         return new String("");
       else
         return input.substring(routepos+1,input.length());
    }

    

    //sendet den eigenen Zug ab.
    // return false: kann nicht senden, da nicht dazu aufgefortert.
    //---------------------------------------------------------------------------------
    public boolean sendturn(point koord){
      if(canITurn==true){
        canITurn=false;
        super.send("Ich_ziehe (Put (" + koord.x + "," + koord.y + "))");
        return true;
      }else{
        return false;
      }
    }
	
    //gibt auf
    // return false: kann nicht senden, da nicht dazu aufgefortert.	
    //---------------------------------------------------------------------------------
 	public boolean resign(){
	  if(canITurn==true){
        canITurn=false;
        super.send("resign");
	System.out.println("Aufgeben wurde an den Server geschickt");
        return true;
      }else{
        System.out.println("Aufgeben konnte nicht gesendet werden da false");
        return false;
      }
	}
	
	//setzt aus
    // return false: kann nicht senden, da nicht dazu aufgefortert.	
    //---------------------------------------------------------------------------------
    public boolean pass(){
	if(canITurn==true){
        canITurn=false;
        super.send("pass");
        return true;
      }else{
        return false;
      }
	}
    
    // schliet den Socket.
    //---------------------------------------------------------------------------------    
    public void close(){
      stopListening=true;
    }
      
}
